//
//  TTSGlideTreeNode.h
//  DragLineView
//
//  Created by LDY on 7/28/11.
//  Copyright 2011 www.goodldy.com All rights reserved.
//

#import <Foundation/Foundation.h>

@interface QFTreeNode : NSObject {
@protected
    QFTreeNode *nodeParent;
    id nodeData;
	NSView *itemView;
    NSMutableArray *nodeChildren;
	BOOL isSelected;
	int levelInt;
	BOOL isExpand;
}
@property BOOL isSelected;
@property (retain) NSView *itemView;
@property int levelInt;
@property BOOL isExpand;
+ (id)treeNodeWithData:(id)data;
- (id)initWithData:(id)data parent:(QFTreeNode *)parent children:(NSArray *)children;

- (void)setNodeData:(id)data;
- (id)nodeData;

- (void)setNodeParent:(QFTreeNode *)parent;
- (QFTreeNode *)nodeParent;

- (void)insertChild:(QFTreeNode *)child atIndex:(NSInteger)index;
- (void)insertChildren:(NSArray *)children atIndex:(NSInteger)index;
- (void)removeChild:(QFTreeNode *)child;
- (void)removeFromParent;
- (void)removeAllChild;

- (NSInteger)indexOfChild:(QFTreeNode *)child;
- (NSInteger)indexOfChildIdenticalTo:(QFTreeNode *)child;
- (NSInteger)indexInPar;

- (NSInteger)numberOfChildren;
- (NSArray *)children;
- (QFTreeNode *)firstChild;
- (QFTreeNode *)lastChild;
- (QFTreeNode *)childAtIndex:(NSInteger)index;
- (QFTreeNode *)nextNode;

// returns YES if 'node' is an ancestor.
- (BOOL)isDescendantOfNode:(QFTreeNode *)node;

// returns YES if any 'node' in the array 'nodes' is an ancestor of ours.
- (BOOL)isDescendantOfNodeInArray:(NSArray *)nodes;

// sort children using the compare: method in nodeData
- (void)recursiveSortChildren;

// Returns the minimum nodes from 'allNodes' required to cover the nodes in 'allNodes'.
// This methods returns an array containing nodes from 'allNodes' such that no node in
// the returned array has an ancestor in the returned array.
+ (NSArray *)minimumNodeCoverFromNodesInArray:(NSArray *)allNodes;

@end


@interface NSArray(MyExtensions)
- (BOOL)containsObjectIdenticalTo:(id)object;
@end

@interface NSMutableArray(MyExtensions)
- (void)insertObjectsFromArray:(NSArray *)array atIndex:(NSInteger)index;
@end

